Option Explicit
Class Table
	dim rows(), columns(), rwsCnt, clmCnt, columnTypes()
	Public Property Get RowCount()
		RowCount = rwsCnt + 1
	End Property
	Public Property Get ColumnCount()
		ColumnCount = clmCnt + 1
	End Property
	Public Sub createTable(rws,clms)
		Dim rw, i
		rwsCnt = rws - 1
		clmCnt = clms - 1
		redim rows(rwsCnt)
		redim columns(clmCnt)
		For i = 0 To (rwsCnt)
			Set rw = New Row
			rw.createRow(clms)
			Set rows(i) = rw
		Next		
	End Sub
	Public Sub addRows(numRows)
		Dim rw, i
		rwsCnt = rwsCnt + numRows
		ReDim Preserve rows(rwsCnt)
		For i = (RowCount-numRows) To rwsCnt
			Set rw = New Row
			rw.createRow ColumnCount
			Set rows(i) = rw
		Next
	End Sub
	Public Sub subtractRow(rwInd)
		Dim trows(), tcnt, i
		If rwInd>rwsCnt Then
			MsgBox "rw Index must be between 0 and " & CStr(rwsCnt)
			Exit Sub
		End If
		If rwInd<0 Then
			MsgBox "rw Index must be between 0 and " & CStr(rwsCnt)
			Exit Sub
		End If
		ReDim trows(rwsCnt-1)
		tcnt=0
		For i = 0 To rwsCnt
			If i <> rwInd Then
				Set trows(tcnt) = rows(i)
				tcnt = tcnt+1
			End if
		Next
		ReDim rows(tcnt-1)
		rwsCnt = tcnt-1
		For i = 0 To rwsCnt
			Set rows(i) = trows(i)
		Next
		Erase trows
	End Sub
	Public Function getRow(index)
		Set getRow = rows(index)
	End Function	
	Public Property Get Records()
		Records = rows
	End Property
	Public Property Get FieldTypes()
		FieldTypes = columnTypes
	End Property
	Public Property Let FieldTypes(valueArr)
		Dim i
		ReDim columnTypes(UBound(valueArr))
		For i=0 To UBound(valueArr)
			columnTypes(i) = valueArr(i)
		Next
	End Property
	Public Property Get Fields()
		Fields = columns
	End Property
	Public Property Let Fields(valueArr)
		Dim i
		ReDim columns(UBound(valueArr))
		For i=0 To UBound(valueArr)
			columns(i) = valueArr(i)
		Next
	End Property
	Public Function findField(fldName)
		Dim outVl, tvl1, tvl2, i
		outVl = -1
		tvl1 = LCase(CStr(fldName))
		For i = 0 To clmCnt
			tvl2 = LCase(CStr(columns(i)))
			If tvl1 = tvl2 Then
				outVl = i
				Exit For
			End If	
		Next
		findField = outVl
	End Function
	Public Sub setCellValue(rw,clm,value)
		Dim ind,r,c
		If(Not IsNumeric(clm)) Then
			ind = findField(clm)
		Else
			ind = clm
		End If
		If ind=-1 Then
			MsgBox "Field " & clm & " does not exist"
			Exit Sub
		End if
		value = getCorrectValue(ind,value)
		Set r = getRow(rw)
		r.setCellValue ind, value
		Set r = nothing
	End Sub
	Public Function getCorrectValue(clm,value)
		Dim outvl,clmTyp
		outvl = value
		If(Not IsEmpty(columnTypes)) Then
			clmTyp = CInt(columnTypes(clm))
			Select Case clmTyp
				Case 129
					outvl = CStr(value)
				Case 5
					If IsNumeric(value) then
						outvl = CDbl(value)
					Else
						outvl = 0
					End if
				Case 7
					If IsDate(value) Then
						outvl = CDate(value)
					Else
						outvl = Now
					End if
				Case 11
					outvl = CBool(value)
			End select
		End if
		getCorrectValue = outvl
	End Function
	Public Function getCellValue(rw,clm)
		Dim ind,r,outvl
		If(Not IsNumeric(clm)) Then
			ind = findField(clm)
		Else
			ind = clm
		End If
		Set r = getRow(rw)
		outvl = r.getCellValue(ind) 
		getCellValue = outvl
		Set r = Nothing
	End Function
	Public Function createGuid
		dim TypeLib, guid
		Set TypeLib = CreateObject("Scriptlet.TypeLib")
		guid = TypeLib.Guid
		guid = Left(guid,Len(guid)-2)
		createGuid = guid
		Set TypeLib = Nothing
	End Function
	Public Function findRowIndex(uidName,uidValue)
		Dim r, ind, outvl, vl2
		outvl = -1
		ind = findField(uidName)
		For r=0 to rwsCnt
			vl2 = getCellValue(r,ind)
			If vl2 = uidValue Then
				outvl = r
				Exit For
			End If
		Next
		findRowIndex = outvl
	End Function
	Public Sub moveRecord(fromRow, toRow)
		Dim cnt, r, cr, nr
		cnt = 0
		ReDim tArr(rwsCnt)
		Set cr = rows(r)
		For r=0 To rwsCnt
			If(r=toRow) Then
				Set rows(cnt) = rows(fromRow)
				cnt = cnt + 1
			End If
			If(r=fromRow) Then
			Else
				Set nr = rows(cnt)
				Set rows(cnt) = cr
				Set cr = nr
				cnt = cnt + 1
			End if
		Next
		Set nr = Nothing
		Set cr = Nothing
	End Sub
	Private Sub Class_Terminate()
		Erase rows
		Erase columns
	End Sub
End Class

Class Dictionary
	Dim k(),v(), rc, ri
	Public Property Get Count()
		Count = rc
	End Property
	Public Property Get Keys()
		Keys = k
	End Property
	Public Property Get Values()
		Values = v
	End Property
	Public sub Add(key,value)
		rc = rc + 1
		ReDim Preserve k(rc-1)
		ReDim Preserve v(rc-1)
		k(rc-1) = key
		v(rc-1) = value 
	End sub
	Public sub Remove(key)
		Dim ind, tk(), tv(), i, tcnt
		If(IsNumeric(key)) Then
			ind = CInt(key)
		Else
			ind = FindIndex(key)
		End If
		If ind = -1 Or ind > rc-1 Or rc = 0 Then
		Else
			ReDim tk(rc-2)
			ReDim tv(rc-2)
			tcnt = 0
			For i=0 To rc-1
				If(i=ind) then
				Else
					tk(tcnt) = k(i)
					tv(tcnt) = v(i)
					tcnt = tcnt+1
				End if
			Next
			ReDim k(tcnt-1)
			ReDim v(tcnt-1)
			rc = tcnt
			For i=0 To rc-1
				k(i)=tk(i)
				v(i)=tv(i)
			Next
			Erase tk
			Erase tv
		End if
	End sub
	Public Function FindValueIndex(value)
		Dim i, outVl
		outVl = -1
		For i=0 To rc-1
			If(v(i)=value)Then
				outVl = i
				Exit For
			End if
		Next
		FindValueIndex = outVl
	End Function
	Public Function FindIndex(key)
		Dim i, outVl
		outVl = -1
		key = LCase(key)
		For i=0 To rc-1
			If(LCase(k(i))=key)Then
				outVl = i
				Exit For
			End if
		Next
		FindIndex = outVl
	End Function
	Public Function GetValue(key)
		Dim ind,outVl
		outVl = -1
		ind = FindIndex(key)
		If(ind>-1)Then
			outVl = v(ind)
		End if
		GetValue = outVl
	End Function
	Public Function GetKey(value)
		Dim ind,outVl
		outVl = -1
		ind = FindValueIndex(value)
		If(ind>-1)Then
			outVl = k(ind)
		End if
		GetKey = outVl
	End Function
	Private Sub Class_Terminate()
		Erase k
		Erase v
	End Sub
End Class

Class Row
	Dim rw(),clms()
	Public Property Get Cells()
		Cells = rw
	End Property
	Public Property Get Fields()
		Fields = clms
	End Property
	Public Property Let Fields(valueArr)
		ReDim clms(UBound(valueArr))
		For i=0 To UBound(valueArr)
			clms(i) = valueArr(i)
		Next
	End Property
	Public Sub createRow(numCells)
		Dim r
		ReDim rw(numCells-1)
		For r=0 To (numCells-1)
			Set rw(r) = New Cell
		Next
	End Sub
	Public Function getCellValue(index)
		getCellValue = rw(index).Value	
	End Function
	Public Sub setCellValue(index,value)
		rw(index).Value = value
	End Sub
	Public Sub addCells(numCells)
		Dim r
		ReDim Preserve rw(UBound(rw)+numCells)
		For r=(UBound(rw)- numCells) To UBound(rw)
			Set rw(r)= New Cell
		Next
	End Sub
	Public Sub Class_Terminate()
		Erase rw
		Erase clms
	End Sub
End Class

Class Cell
	Public Value	
End Class

'Dim rw, vl
'Set rw = New Row
'rw.createRow(5)
'rw.setCellValue 2, 6
'rw.addCells 6
'rw.setCellValue 10, 12
'vl = rw.getCellValue(10)
'Set rw = nothing
'MsgBox CStr(vl)

'Dim tbl,vl,i,findex, ft
'Set tbl = New Table
'tbl.createTable 6,5
'tbl.Fields = Array("uid","f1","f2","f3","f4")
'tbl.FieldTypes = Array(129,5,5,5,129)
'For i=0 To tbl.RowCount-1
'	vl = tbl.createGuid()
'	tbl.setCellValue i, "f4", vl
'Next
'tbl.addRows(1)
'vl = tbl.createGuid()
'tbl.setCellValue tbl.RowCount-1,"f4",vl
'For i=0 To tbl.RowCount-1
'	MsgBox "Total records = " & CStr(i) & " uid = " & tbl.getCellValue(i,"f4")
'Next
'tbl.moveRecord tbl.RowCount-1, 0
'MsgBox "Total records = " & UBound(tbl.Records) & " uid = " & tbl.getCellValue(0,"f4")
'Dim d, ky
'Set d = New Dictionary
'd.Add "t", 1
'd.Add "a", 2
'MsgBox d.GetKey(2)