﻿option explicit

'Global Variables
Dim subPlotUid, plotUid, setupUid, projectUid, treeUid, spUid 'values used to link plots with subplots, and trees tables
Dim subplots, trees, setup, species, gps 'path to setup, subplot, and tree relational dbf tables
Dim dtProject, dtSetup, dtPlot, dtSubplot, dtTree, dtSpecies, dtGPS, dtGPSsetup 'data tables used to update values
Dim luSpcd, luStcd, luCtype, luBrcd, luPct 'lookup dictionary used for comboboxes
Dim check, rcd, cruiseType, cruiseValue, plt, subplt, collectData, gpsPositionNumber

Sub Include(sInstFile)
    Dim s, oFSO
    Set oFSO = Application.CreateAppObject("file")
    On Error Resume Next
    If oFSO.Exists(sInstFile) Then
		'Application.MessageBox "file DataTable exists"
        oFSO.Open(sInstFile)
		do while not oFSO.EOF
			s = s & oFSO.ReadLine & vbCrLf
		loop
		oFSO.Close
        ExecuteGlobal s
    End If
    On Error Goto 0
    Set oFSO = Nothing
End Sub

function fillDictionary(path,cd,txt)
	Dim rcds, outDic, trcd, sql
	set outDic = new Dictionary
	set rcds = Application.CreateAppObject("RecordSet")
	sql = "[use] = 1 and [utype] < 3"
	rcds.Open path, 1
	trcd = rcds.Find(sql)
	do while trcd > 0
		outDic.Add rcds.Fields(cd).Value, rcds.Fields(txt).Value
		trcd = rcds.Find(sql,,trcd)
	loop
	rcds.Close
	set fillDictionary = outDic
	set rcds = nothing
	set outDic  = nothing
End function

Function createGuid()
	createGuid = System.CreateGuid
End Function

'Application.MessageBox Application.Path & "\Applets\DataTable.vbs"
Include(Application.Path & "\Applets\DataTable.vbs")
'Application.MessageBox "Included DataTable"
set luSpcd = fillDictionary(Application.Path & "\Applets\Tree_Data_Collection\spcd.dbf","SPCD","COMMON_NAM")
'Application.MessageBox "filled Dictionary Spcd"
set luStcd = fillDictionary(Application.Path & "\Applets\Tree_Data_Collection\stcd.dbf","CODE","TEXT")
'Application.MessageBox "filled Dictionary Stcd"
set luCtype = fillDictionary(Application.Path & "\Applets\Tree_Data_Collection\crcd.dbf","CODE","TEXT")
'Application.MessageBox "filled Dictionary crcd"
set luBrcd = fillDictionary(Application.Path & "\Applets\Tree_Data_Collection\brcd.dbf","CODE","TEXT")
'Application.MessageBox "filled Dictionary Spcd"
set luPct = fillDictionary(Application.Path & "\Applets\Tree_Data_Collection\pctcd.dbf","CODE","TEXT")


collectData=false
gpsPositionNumber = 0

Sub LoadFormStartup
'Called when edit form is openned 'If there are no shapefile layers in the map, then exit
	call check_plot_layers 'sets the plotuid, setupuid, and projectuid
	if check = 3 then
		call setup_exists
		if check = 1 then
		else
			Layer.Forms("frmSetup").Show
		end if
	else
	end if
End Sub

Function fillDataTable(frmName)
'Fills the data table based on uids. New values are created in the dbf file and values are set in the data table 
	Dim rcds, path, sql, outTbl, fcnt, fldArr, rcnt, fldName, fld, fldTypeArr, guid
	sql = "[uid] = "
	set rcds = Application.CreateAppObject("recordset")
	Select Case frmName
		Case "frmSetup"
			path = setup
			rcds.Open path, 1
			sql = sql & """" & CStr(setupUid)	& """"		
		Case "frmSubplot"
			path = subplots
			rcds.Open path, 1
			sql = "[uid] = """ & subPlotUid	& """"
		Case "frmtrees"
			path = trees
			rcds.Open path, 1
			sql = "[subplotUid] = """ & subPlotUid & """ AND [utype] < 3"
		Case "frmGPS"
			path = gps
			rcds.Open path, 1
			sql = "[plotUid] = """ & CStr(plotUid) & """ AND [utype] < 3"
		Case "frmSpecies"
			path = species
			rcds.Open path, 1
			sql = sql & """" & CStr(spUid) & """"
		Case else
	End Select
	set outTbl = new Table
	fcnt = rcds.Fields.Count
	outTbl.createTable 1, fcnt
	redim fldArr(fcnt-1)
	redim fldTypeArr(fcnt-1)
	fcnt = 0
	for each fld in rcds.Fields
		fldName = fld.Name
		fldArr(fcnt) = fldName
		fldTypeArr(fcnt) = fld.Type
		fcnt = fcnt + 1
	Next
	outTbl.Fields = fldArr
	outTbl.FieldTypes = fldTypeArr
	rcd = rcds.Find(sql)
	if rcd = 0 then
		guid = createGuid()
		'rcds.AddNew
		outTbl.setCellValue 0,"uid",guid
		outTbl.setCellValue 0,"utype",1
		select case frmName
			Case "frmSubplot"
				outTbl.setCellValue 0,"plotUid",plotUid
				outTbl.setCellValue 0,"subplot",subplt
				outTbl.setCellValue 0,"pctpine",0
				outTbl.setCellValue 0,"pctbare",0
				outTbl.setCellValue 0,"burn",6
				outTbl.setCellValue 0,"pctherb",0
				outTbl.setCellValue 0,"pctbroad",0
				outTbl.setCellValue 0,"pctsaw",0
				outTbl.setCellValue 0,"pctcwd",0
				subPlotUid = guid
			Case "frmtrees"
				outTbl.setCellValue 0,"subplotUid",subPlotUid
				outTbl.setCellValue 0,"status",1
				outTbl.setCellValue 0,"sp",0
				outTbl.setCellValue 0,"cnt",1
				outTbl.setCellValue 0,"dbh",0
				treeUid = guid
			Case "frmSetup"
				outTbl.setCellValue 0,"projectUid",projectUid
				outTbl.setCellValue 0,"uid",setupUid
				'setupUid = guid
			Case "frmSpecies"
				outTbl.setCellValue 0,"use",1 
				outTbl.setCellValue 0,"lbl","1   |0   |not set                  |" & guid 
				spUid = guid
			Case "frmGPS"
				outTbl.setCellValue 0,"plotUid",plotUid 
			Case else
		end select
	else
		guid = rcds.Fields("uid").Value
		select case frmName
			Case "frmSubplot"
				subPlotUid = guid				
			Case "frmtrees"
				treeUid = guid
			Case "frmSetup"
				setupUid = guid
				sql = sql & """" & CStr(setupUid)	& """ AND [utype] < 3"
			Case "frmSpecies"
				spUid = guid
		end select
	end if
	rcnt = 0
	Do while rcd <> 0
		if rcnt = 0 then
		else
			'Application.MessageBox "adding Row rcd = " & Cstr(rcd) & ":" & sql 
			outTbl.addRows 1
		end if
		for each fld in rcds.Fields
			outTbl.setCellValue rcnt,fld.Name,fld.Value
		Next
		rcd = rcds.Find(sql, ,rcd)
		rcnt = rcnt + 1
	Loop
	set fillDataTable = outTbl
	rcds.Close
	set rcds = Nothing
End Function

sub setSubPlotUid(subPlotNumber)
	subplt = subPlotNumber
	subPlotUid = getUid(subplots,"[plotUid] = """ & plotUid & """ and [subplot] = " & CStr(subplt),"uid")
end sub

sub createFile(flpath)
	dim myfile
	set myfile = Application.CreateAppObject("File")
	if myfile.Exists(flpath) then
	else
		myfile.Copy Application.Path & "\Applets\Tree_Data_Collection\" & right(flpath,len(flpath)-InStrRev(flpath,"_")+1), flpath
	end if
	set myfile = nothing
end sub

Function getUid(path2, sql, fldName)
	Dim rcds2, outvl, weOpen
	set rcds2 = Application.CreateAppObject("recordset")
	weOpen = True
	createFile(setup)
	if (LCase(path2) = LCase(Layer.FilePath)) then
		weOpen = False
		set rcds2 = Layer.Records
	else
		rcds2.Open path2, 1
	end if
	outvl = rcds2.Find(sql)
	if outvl > 0 then
		outvl = rcds2.Fields(fldName).Value
	else
		outvl = -1
	end if
	if weOpen then
		rcds2.Close
	end if
	set rcds2 = nothing
	getUid = outvl
End Function

sub updateDbfValues(frmName,tbl)
'call this on ok button push
	Dim rcds, path, sql, uidIndex, uidValue, r, weOpen, fld
	call updateCurrentTableRecord(frmName,tbl)
	set rcds = Application.CreateAppObject("recordset")
	weOpen = true
	Select Case frmName
		Case "frmSetup"
			path = setup
		Case "frmSubplot"
			path = subplots
		Case "frmtrees"
			path = trees
		Case "frmGPS"
			path = gps
			'Application.MessageBox "updated Current Record " & path
		Case "frmSpecies"
			path = species
		Case else
			exit sub
	End Select
	rcds.Open path, 2
	uidIndex = tbl.findField("uid")
	for r=0 to tbl.RowCount-1
		uidValue = tbl.getCellValue(r,uidIndex)
		sql = "[uid] = """ & uidValue & """"
		rcd = rcds.Find(sql)
		'Application.MessageBox Cstr(rcd)
		if rcd = 0 then
			'Application.MessageBox "adding record"
			rcds.AddNew
		end if
		for each fld in rcds.Fields
			'Application.MessageBox fld.Name & ": " & CStr(tbl.getCellValue(r,fld.Name))
			fld.Value = tbl.getCellValue(r,fld.Name)			
		Next
		rcds.Update
	Next
	if(weOpen) then
		rcds.Close
	end if
	set rcds = Nothing	
end sub

sub updateCurrentTableRecord(frmName,tbl)
	Dim path, sql, uidValue, c, theControls, pg, cntName, cntType, cntValue, rwIndex
	Select Case frmName
		Case "frmSetup"
			pg = "pgSetup"
			uidValue = setupUid
		Case "frmSubplot"
			pg = "pgSubplot"
			path = subplots
			uidValue = subPlotUid
		Case "frmtrees"
			pg = "pgtrees"
			uidValue = treeUid
		Case "frmSpecies"
			pg = "pgSpecies"
			uidValue = spUid
		Case else
			'Application.MessageBox "Exit Current Record"
			exit sub
	End Select
	rwIndex = tbl.findRowIndex("uid",uidValue)
	set theControls = Layer.Forms(frmName).Pages(pg).Controls
	for each c in theControls
		cntName = lCase(Right(c.Name,len(c.Name)-3))
		cntType = LCase(c.Type)
		cntValue = c.Value
		if cntType = "edit" then
			cntValue = c.Value
			tbl.setCellValue rwIndex, cntName, cntValue	
		elseif cntType = "combobox" then
			select case cntName
				Case "sp"
					cntValue = luSpcd.GetKey(c.Value)
					'Application.MessageBox "updating rowIndex (" & Cstr(rwIndex) & ") sp = " & Cstr(cntValue)
				Case "status"
					cntValue = luStcd.GetKey(c.Value)
				Case "ctype"
					cntValue = luCtype.GetKey(c.Value)
				case "burn"
					cntValue = luBrcd.GetKey(c.Value)
				case else
					cntValue = luPct.GetKey(c.Value)
			end select
			tbl.setCellValue rwIndex, cntName, cntValue
		end if
	Next
	if(frmName = "frmSpecies") then
		Dim lblValue
		lblValue = formatStrValue(tbl.getCellValue(rwIndex,"use"),4) & "|" & formatStrValue(tbl.getCellValue(rwIndex,"SPCD"),4) & "|" & formatStrValue(tbl.getCellValue(rwIndex,"COMMON_NAM"),25) & "|" & tbl.getCellValue(rwIndex,"uid")
		tbl.setCellValue rwIndex, "lbl", lblValue
	elseif(frmName = "EDITFORM") then
		tbl.setCellValue rwIndex, "visited", 1
		'Application.MessageBox Cstr(plotUid) & "visited = 1"		
	end if
	call updateRow(tbl,rwIndex)
	set theControls = Nothing
end sub

sub update_labels(form)
	'Called on load event for forms or activate event on pages. Fills controls with data table values
	dim objTheForm, objTheControls, pg
	if(form = "EDITFORM") then
		pg = "pg" & form
	elseif (form = "pgtreesview") then
		pg = form
		form = "frmtrees"
	else
		pg = "pg" & right(form,len(form)-3)
	end if
	Set objTheForm = Layer.Forms(form)
	Set objTheControls = objTheForm.Pages(pg).Controls
	select case pg
		case "pgtrees"
			objTheControls("lblsubplot").Value = "Plot " & CStr(plt) & " Subplot " & CStr(subplt)
			objTheControls("lblcount").Value = " of " & CStr(dtTree.RowCount)
		case "pgtreesview"
			objTheControls("lblsubplot").Value = "Plot " & CStr(plt) & " Subplot " & CStr(subplt)
		case "pgSubplot"
			objTheControls("lblsubplot").Value = "Plot " & CStr(plt) & " Subplot " & CStr(subplt)
		case "pgEDITFORM"
			objTheForm.Pages(pg).Caption = "Plot " & CStr(plt)
		case "pgSetup"
			objTheControls("lblplot").Value = "Plot " & CStr(plt)
	end select
	set objTheForm = nothing
	set objTheControls = nothing
end sub

sub check_plot_layers
'Check to see if a record within a point layer is selected and if the point layer has plotUid and setupUid. If so then gets the values associated with the selected point
	trees = ""
	dim l, path, visited
	check = 0
	visited = 0
	dim lyr, rcds, flds, srcd 
	set lyr = Map.SelectionLayer
	path = lyr.FilePath
	trees = left(path,len(path)-4) & "_trees.dbf"
	subplots = left(path,len(path)-4) & "_subplots.dbf"
	setup = left(path,len(path)-4) & "_setup.dbf"
	species = Application.Path & "\Applets\Tree_Data_Collection\spcd.dbf"
	gps = left(path,len(path)-4) & "_gps.dbf"
	set rcds = lyr.Records
	srcd = Map.SelectionBookmark
	rcds.Bookmark = srcd
	set flds = rcds.Fields
	for each l in flds
		if Ucase(l.Name) = "UID" or Ucase(l.Name) = "SETUPUID" or Ucase(l.Name) = "OBJECTID" then
			check = check + 1
		elseif Ucase(l.Name) = "VISITED" then
			visited = 1
		else
		end if
	next
	if check = 3 then
		plotUid = flds.Item("uid").Value
		setupUid = flds.Item("setupUid").Value
		plt = flds.Item("OBJECTID").Value
		projectUid = getUid(setup, "[uid] = """ & setupUid & """", "projectUid")
	else
		Application.MessageBox "Improperly Formated plot file. Please reload a properly desinged plot file!", vbExclamation, "Improperly formated"
	end if
	set flds = nothing
	set rcds = nothing
	set lyr = nothing			
end sub

sub setup_exists
'checks to see if the related table setup exists. If so get the projectUid, cruise type (BAF or Fixed) and cruise value (BAF value or fixed radius)
	dim myfile, myarray, i, setup_rcds, srcd, sql
	set myfile = Application.CreateAppObject("file")
	redim myarray(3)
	myarray(0) = trees
	myarray(1) = subplots
	myarray(2) = setup
	myarray(3) = gps
	for each i in myarray
		if myfile.Exists(i) then
		else
			myfile.Copy Application.Path & "\Applets\Tree_Data_Collection\" & right(i,len(i)-InStrRev(i,"_")+1), i
		end if
	next
	set setup_rcds = Application.CreateAppObject("recordset")
	setup_rcds.Open setup, 1
	sql = "[uid]=""" & CStr(setupUid) & """"
	srcd = setup_rcds.Find(sql)
	if srcd > 0  then 
		check = 1
		cruiseType = setup_rcds.Fields("ctype").Value
		cruiseValue = setup_rcds.Fields("Value").Value
		projectUid = setup_rcds.Fields("projectUid").Value
	else
		check = 0
		cruiseType = "FIXED"
		cruiseValue = 4
	end if
	setup_rcds.Close
	set setup_rcds = nothing
	set myfile = nothing
	erase myarray 
End sub

Sub setTreeCombobox	
	dim controls,i, vl, tx
	set controls = Layer.Forms("frmtrees").Pages("pgtrees").Controls
	controls("cmbsp").Clear
	controls("cmbsp").AddItemsFromTable species,"COMMON_NAM","COMMON_NAM", "[use] = 1 and [utype] < 3"
	controls("cmbstatus").Clear
	controls("cmbstatus").AddItemsFromTable Application.Path & "\Applets\Tree_Data_Collection\stcd.dbf","TEXT","TEXT", "[use] = 1 and [utype] < 3"' order [sort]"
	set controls = nothing
End Sub

Sub setCruiseCombobox
	dim cnt
	set cnt = Layer.Forms("frmSetup").Pages("pgSetup").Controls("cmbctype")
	cnt.Clear
	cnt.AddItemsFromTable Application.Path & "\Applets\Tree_Data_Collection\crcd.dbf","TEXT","TEXT", "[use] = 1 and [utype] < 3"
	set cnt = nothing
End Sub

Sub setSubplotComboboxes
	dim cntrs, cnt
	set cntrs = Layer.Forms("frmSubplot").Pages("pgSubplot").Controls
	for each cnt in cntrs
		if LCase(cnt.Type) = "combobox" then
			cnt.Clear
			'Application.Messagebox cnt.Name
			select case cnt.Name
				Case "cmbburn"
					cnt.AddItemsFromTable Application.Path & "\Applets\Tree_Data_Collection\brcd.dbf","TEXT","TEXT", "[use] = 1 and [utype] < 3"
				case else
					cnt.AddItemsFromTable Application.Path & "\Applets\Tree_Data_Collection\pctcd.dbf","TEXT","TEXT", "[use] = 1 and [utype] < 3"
			end select
		end if
	next		
	set cnt = nothing
	set cntrs = nothing
End Sub

Sub updateFormValues(form, tbl)
'updates the form values based on field names and control names
	dim theControls, rwInd, c, uIndex
	dim cntName, fldInd, cntType, form2, nvl
	form2 = LCase(right(form,len(form)-3))
	if form = "editform" then
		form2 = form
	end if
	set theControls =Layer.Forms("frm" & form2).Pages("pg" & form2).Controls
	Select Case form2
		case "trees"
			uIndex = treeUid
		case "setup"
			uIndex = setupUid
		case "subplot"
			uIndex = subPlotUid
		case "project"
			uIndex = projectUid
		case "species"
			uindex = spUid
		case else
			exit sub
	end select
	rwInd = tbl.findRowIndex("uid",uIndex)
	'Application.MessageBox Cstr(rwInd)
	if rwInd < 0 then
		Application.MessageBox "Can't find related records. Setting to first record."
		rwInd = 0
	end if
	for each c in theControls
		cntName = c.Name
		cntName = LCase(Right(cntName,len(cntName)-3))
		fldInd = tbl.findField(cntName)
		cntType = LCase(c.Type)
		if fldInd >-1 then
			if cntType = "edit" then
				c.Value = tbl.getCellValue(rwInd,fldInd)
			elseif cntType = "combobox" then
				select case cntName
					Case "sp"
						'Application.MessageBox "table value = " & Cstr(tbl.getCellValue(rwInd,fldInd))
						nvl = luSpcd.GetValue(tbl.getCellValue(rwInd,fldInd))
						c.Value = nvl
						'Application.MessageBox Cstr("List count = " & c.ListCount)
						c.ListIndex = luSpcd.findIndex(tbl.getCellValue(rwInd,fldInd))
						'Application.MessageBox "lookup value = " & CStr(luSpcd.Count) & " " & CStr(nvl) & " " & CStr(c.ListIndex)
					Case "status"
						nvl = luStcd.GetValue(tbl.getCellValue(rwInd,fldInd))
						c.Value = nvl
						c.ListIndex = luStcd.findIndex(tbl.getCellValue(rwInd,fldInd))
					Case "ctype"
						nvl = luCtype.GetValue(tbl.getCellValue(rwInd,fldInd))
						c.Value = nvl
						c.ListIndex = luCtype.findIndex(tbl.getCellValue(rwInd,fldInd))
					Case "burn"
						nvl = luBrcd.GetValue(tbl.getCellValue(rwInd,fldInd))
						c.Value = nvl
						c.ListIndex = luBrcd.findIndex(tbl.getCellValue(rwInd,fldInd))
					Case else
						nvl = luPct.GetValue(tbl.getCellValue(rwInd,fldInd))
						c.Value = nvl
						c.ListIndex = luPct.findIndex(tbl.getCellValue(rwInd,fldInd))
				end select
			end if
		end if
	Next
	set theControls = nothing
	call update_labels(form)
End Sub

Sub addTreeRow
	dim outRwInd, guid, theControl,i
	set theControl = ThisEvent.Object
	call updateCurrentTableRecord("frmtrees",dtTree)
	dtTree.AddRows(1)
	guid = createGuid()
	outRwInd = dtTree.RowCount - 1
	dtTree.setCellValue outRwInd, "uid", guid
	dtTree.setCellValue outRwInd, "utype", 1
	dtTree.setCellValue outRwInd, "cnt", 1
	dtTree.setCellValue outRwInd, "subplotUid",subPlotUid
	dtTree.setCellValue outRwInd, "status", 1
	dtTree.setCellValue outRwInd, "sp", 0
	treeUid = guid
	call updateFormValues("frmtrees",dtTree)
	theControl.Parent.Controls("lbltree").Value = CStr(dtTree.RowCount)
	theControl.Parent.Controls("lblcount").Value = " of " & CStr(dtTree.RowCount)
	set theControl = nothing
end Sub

Sub subtractTreeRow
	dim rcds, trcd, theControl, rwIndex
	set theControl = ThisEvent.Object
	rwIndex = dtTree.findRowIndex("uid",treeUid)
	if rwIndex = 0 then
		Application.MessageBox "Can't delete last record. If you want no tally set tree count = 0"
		Exit Sub
	end if
	set rcds = Application.CreateAppObject("recordset")
	rcds.Open trees, 2
	trcd = rcds.Find("[uid] = """ & treeUid & """")
	if trcd>0 then
		rcds.Fields("utype").Value = 3
		rcds.Update
	end if
	dtTree.subtractRow(rwIndex)
	rcds.Close
	set rcds = Nothing
	treeUid = dtTree.getCellValue((rwIndex-1),"uid")
	call updateFormValues("frmtrees",dtTree)
	theControl.Parent.Controls("lbltree").Value = CStr(rwIndex)
	theControl.Parent.Controls("lblcount").Value = " of " & CStr(dtTree.RowCount)
	set theControl = Nothing
End Sub

Sub updateRow(tbl,rwIndex)
	dim cvalue
	cvalue = tbl.getCellValue(rwIndex,"utype")
	if (cvalue > 0) and (cvalue < 4) then
	else
		tbl.setCellValue rwIndex, "utype", 2
	end if
end Sub

sub move_record(spaces)
	dim theControl
	dim treenumber, maxrecords, rwIndex
	call updateCurrentTableRecord("frmtrees",dtTree)
	rwIndex = dtTree.findRowIndex("uid",treeUid)
	treenumber = rwIndex + spaces + 1
	maxrecords = dtTree.RowCount
	if treenumber > maxrecords then
		Application.MessageBox "You have reached the last record!" & vbnewline & "If you want to add a new record press the '+' button"
		Exit Sub
	elseif treenumber < 1 then
		Application.MessageBox "You have reached the first record!" & vbnewline & "If you want to delete a record press the '-' button"
		Exit Sub
	else
		treeUid = dtTree.getCellValue(rwIndex+spaces,"uid")
	end if
	Layer.Forms("frmtrees").Pages("pgtrees").Controls("lbltree").Value = CStr(treenumber)
	call updateFormValues("frmtrees",dtTree)
end sub

sub view_select
	dim theViewControl
	dim form,treenumber
	set theViewControl = ThisEvent.Object
	if theViewControl.ListIndex > 0 then
		treenumber = theViewControl.ListIndex
		treeUid = dtTree.getCellValue(treenumber-1,"uid")
		theViewControl.Parent.Parent.Pages("pgtrees").Activate
		theViewControl.Parent.Parent.Pages("pgtrees").Controls("lbltree").Value = treenumber
		call updateFormValues("frmtrees", dtTree)
		set theViewControl = nothing
	else
		set theViewControl = nothing
		Exit sub
	end if
end sub

sub update_list_view
	dim count, i, a, m, index_header, index_value
	dim theViewControls, myarray
	set theViewControls = Layer.Forms("frmtrees").Pages("pgtreesview").Controls
	call updateCurrentTableRecord("frmtrees",dtTree)
	index_header = "#   |  SP| DBH| STA| CNT|UTYP| UID                                  | SUBPLOTUID                                  " 
	theViewControls ("lsttreesview").Clear
	theViewControls ("lsttreesview").AddItem index_header,index_header
	for i=0 to dtTree.RowCount-1
		redim myarray(5)
		myarray(0) = CStr(i + 1)
		myarray(1) = CStr(dtTree.getCellValue(i,"sp"))
		myarray(2) = CStr(dtTree.getCellValue(i,"dbh"))
		myarray(3) = CStr(dtTree.getCellValue(i,"status"))
		myarray(4) = CStr(dtTree.getCellValue(i,"cnt"))
		myarray(5) = CStr(dtTree.getCellValue(i,"utype"))
		count = 0
		for each m in myarray
			if len(m) < 4 then
				for a = 1 to (4-len(m))
					m = m & " "
				next
			end if
			myarray(count) = m
			count = count + 1
		next
		index_value = join(myarray,"|") & "|" & dtTree.getCellValue(i,"uid") & "|" & dtTree.getCellValue(i,"subplotUid")
		theViewControls("lsttreesview").AddItem index_value, index_value
	next
	Erase myarray
	set theViewcontrols = nothing
end sub

function formatStrValue(value,lng)
	Dim outvl,clng
	lng = lng + 1
	clng = len(Cstr(value))
	outvl = CStr(value)
	if clng < lng then
		outvl = outvl & space(lng-clng)
	elseif clng > lng then
		outvl = left(outvl,lng)	 
	end if
	formatStrValue = outvl
end function

sub fillListViewAddTree
	dim control,i, vl, tx
	set control = Layer.Forms("frmAddTree").Pages("pgAddTree").Controls("lstTree")
	control.Clear
	control.AddItemsFromTable species,"lbl","lbl", "[utype] < 3"
	set control = nothing
end sub

sub selectAddTree
	dim rcds, theControl, ind, use, ln, ovl,ary, svl,code,common,ut
	set theControl = ThisEvent.Object.Parent("lstTree")
	ind = theControl.ListIndex
	ln = theControl.Value
	ary = split(ln,"|")
	spUid = ary(ubound(ary))
	use = CInt(ary(0))
	code = CInt(ary(1))
	common = Trim(ary(2))
	if(use=1) then
		ovl=0
	else
		ovl = 1
	end if
	svl = formatStrValue(ovl,len(ary(0))-1)
	ary(0) = svl
	ln = join(ary,"|")
	set rcds = Application.CreateAppObject("recordset")
	rcds.Open species, 2
	rcds.Find "[uid] = """ & spUid & """"
	rcds.Fields("use").Value = ovl
	rcds.Fields("lbl").Value = ln
	ut = Cint(rcds.Fields("utype").Value)
	if(ut = 1 or ut = 3) then 
	else
		rcds.Fields("utype").Value = 2
	end if
	rcds.Update
	rcds.Close
	fillListViewAddTree
	theControl.ListIndex = ind
	set rcds = nothing
	set theControl = nothing
	Erase ary
end sub

sub removeAddTree
	dim theControl, rcds, sql, uid, ind, ary
	set theControl = ThisEvent.Object.Parent("lstTree")
	set rcds = Application.CreateAppObject("recordset")
	ind = theControl.ListIndex
	if ind >= (theControl.ListCount - 1) then
		ind = ind-1
	elseif ind = 0 then
		ind = -1
	end if
	ary = split(theControl.Value,"|")
	uid = ary(3)
	sql = "[uid] = """ & uid & """"
	rcds.Open species, 2
	rcds.Find sql
	rcds.Fields("utype").Value = 3
	rcds.Fields("use").Value = 0
	rcds.Update
	rcds.Close
	fillListViewAddTree
	theControl.ListIndex = ind
	set rcds = nothing
	set theControl = nothing
	Erase ary
end sub

sub takePicture
	dim path, fl, rslt
	path = replace(Layer.FilePath,Layer.Name&".shp","") & "PlotPics"
	set fl = Application.CreateAppObject("file")
	if(not fl.Exists(path)) then
		'Application.MessageBox "creating directory" & path
		fl.CreateDirectory(path)
	end if
	path = path & "\" & plotUid & ".jpg"
	if(fl.Exists(path)) then
		rslt = Application.MessageBox("File exist! Do you want to replace?", 4, "File Exists")
		if( rslt = 6) then
			'Application.MessageBox "taking picture"
			MultiMedia.CaptureStill(path)
		else
			'show image
		end if
	else
		MultiMedia.CaptureStill(path)
	end if
	set fl = nothing
end sub

sub collectGPS
	Dim mpos, i, rCnt, dif, rIndex, weOpen, ln, optArr
	dim view
	gpsPositionNumber = 0
	optArr = getAveragingOptions
	set dtGPS = fillDataTable("frmGPS")
	mpos = optArr(0)
	if(optArr(2)=False or mpos < 6) then
		Application.MessageBox "You must enable averaging and have more than 5 positions!", vbInformation, "GPS setup"
		Application.ExecuteCommand("gpsoptions")
		exit sub
	end if
	rCnt = dtGPS.RowCount
	'Application.MessageBox "Row count = " & Cstr(rCnt)
	dif = mpos-rCnt
	'Application.MessageBox "Diff = " & Cstr(dif)
	if dif > 0 then
		call dtGPS.AddRows(dif)
		'Application.MessageBox "Added " &  Cstr(dif) & " new row count = " & Cstr(dtGPS.RowCount)
		for i = rCnt to mpos-1
			rIndex = i
			dtGPS.setCellValue rIndex, "uid", createGuid()
			dtGPS.setCellValue rIndex, "plotUid", plotUid
			dtGPS.setCellValue rIndex, "utype", 1
			dtGPS.setCellValue rIndex, "position", i
			'Application.MessageBox "set value for rindex " & cStr(rIndex)
		next
		
		view = false
	elseif dif < 0 then
		if Application.MessageBox("Positions exist. Do you want to replace?",4,"Replace") = 6 then
			view = false
		else
			view = true
		end if
		for i = mpos to rCnt-1
			rIndex = i
			'Application.MessageBox "Setting rowindex " & Cstr(rIndex) & " to 3"
			dtGPS.setCellValue rIndex, "utype", 3
		next
	else
		if Application.MessageBox("Positions exist. Do you want to replace?",4,"Replace") = 6 then
			view = false
		else
			view = true
		end if
	end if
	if(view) then
	else
		weOpen = false
		if(Application.GPS.IsOpen) then
		else
			weOpen = True
			Application.GPS.Open
			Application.MessageBox "Activated GPS",vbInformation, "Activate"
		end if
		collectData = True
		Application.ExecuteCommand("movepointtogps") 
		collectData = False
		if(weOpen) then
			if Application.MessageBox("Do you want to deactivate the GPS?", vbYesNo, "Deactivate") = 6 then
				Application.GPS.Close
			end if
		end if
	end if
	call removeGpsZeros
	call updateDbfValues("frmGPS",dtGPS)
end sub

sub removeGpsZeros
	Dim r, xvalue, sdel, xindex
	xindex = dtGPS.findField("x")
	sdel = -1
	for r=0 to dtGPS.RowCount-1
		xvalue = dtGPS.getCellValue(r,xindex)
		if xvalue=0 then
			sdel = r
			exit for
		end if
	next
	if sdel>-1 then
		for r=dtGPS.RowCount-1 to sdel Step -1
			dtGPS.SubtractRow(r)
		next
	end if
end sub

sub setupGpsForm
	Dim theControl, theLabel, i, rCnt, ln, xp, yp, h, s, sh
	set theControl = Layer.Forms("frmGPS").Pages("pgGPS").Controls("lstgps")
	set theLabel = Layer.Forms("frmGPS").Pages("pgGPS").Controls("lblgps")
	rCnt = dtGPS.RowCount
	theControl.Clear
	'Application.MessageBox "Row count = " & Cstr(rCnt)
	for i = 1 to dtGPS.RowCount
		sh = CInt(dtGPS.getCellValue(i-1,"utype"))
		if sh < 3 then
			xp = dtGPS.getCellValue(i-1,"x")
			yp = dtGPS.getCellValue(i-1,"y")
			h = dtGPS.getCellValue(i-1,"hdop")
			s = dtGPS.getCellValue(i-1,"sat")
			ln = formatStrValue(i,3) & "|" & formatStrValue(xp,10) & "|" & formatStrValue(yp,10) & "|" & formatStrValue(h,5) & "|" & formatStrValue(s,3)
			theControl.AddItem ln, ln
		end if
	next
	theLabel.Value = "Viewing Data"
	set theControl = nothing
	set theLabel = nothing
end sub

function getGpsValues
	dim myArray
	redim myArray(3)
	myArray(0) = CDbl(Application.GPS.Properties("HDOP"))
	myArray(1) = CInt(Application.GPS.Satellites.Count)
	myArray(2) = CDbl(Application.GPS.X)
	myArray(3) = CDbl(Application.GPS.Y)		
	getGpsValues = myArray
end function

sub updateGpsTable
	dim gpsArray, p
	if(collectData) then
		if gpsPositionNumber > dtGPS.RowCount-1 then
			gpsPositionNumber = 0
		end if
		gpsArray = getGpsValues
		p = gpsPositionNumber + 1
		dtGPS.setCellValue gpsPositionNumber, "x", gpsArray(2)
		dtGPS.setCellValue gpsPositionNumber, "y", gpsArray(3)
		dtGPS.setCellValue gpsPositionNumber, "position", p
		dtGPS.setCellValue gpsPositionNumber, "UTC", Application.GPS.Properties("UTC")
		dtGPS.setCellValue gpsPositionNumber, "hdop", gpsArray(0)
		dtGPS.setCellValue gpsPositionNumber, "sat", gpsArray(1)
		gpsPositionNumber = p
	end if
end sub

function getAveragingOptions 'returns (points,verticies,enabled)
	dim fl, ln, pt, mArr, outArr, ar
	Redim outArr(2)
	outArr(0) = 0
	outArr(1) = 0
	outArr(2) = false
	pt = Application.System.Properties("PersonalFolder") & "\My ArcPad\ArcPadPrefs.apx"
	'Application.MessageBox pt
	Set fl = Application.CreateAppObject("file")
	if fl.Exists(pt) then
		fl.Open pt, apFileRead
		Do while not fl.EOF
			ln = Trim(fl.ReadLine)
			'Application.MessageBox ln
			if(InStr(1,ln,"<AVERAGING")>0) then
				'<AVERAGING point="30" vertex="5" enabled="true"/>
				mArr = Split(ln," ")
				if ubound(mArr) > 0 then
					for each ar in mArr
						ar = Replace(ar,"/>","")
						if InStr(1,ar,"point") > 0 then
							outArr(0) = Cint(Replace(Split(ar,"=")(1),"""",""))
						elseif InStr(1,ar,"vertex") > 0 then
							outArr(1) = Cint(Replace(Split(ar,"=")(1),"""",""))
						elseif InStr(1,ar,"enabled") > 0 then
							outArr(2) = Cbool(Mid(Split(ar,"=")(1),2,4))
						end if
					next
				end if
				erase mArr
				exit do
			end if
		loop
		fl.Close
	else
		Application.MessageBox "Can't find file"
	end if
	getAveragingOptions = outArr
	set fl = nothing 
end function

sub setVisitedZero
	Dim rcds
	set rcds = Layer.Records
	rcds.Bookmark = Map.SelectionBookmark
	rcds.Fields("visited").Value = 0
	rcds.Fields("utype").Value = 0
	rcds.Update
	set rcds = nothing
end sub

sub plotCheck
	Dim rcds, rcds2, sql, trcd, cnt, suid, sql2, slst, path, fl, xvalue
	set rcds = Application.CreateAppObject("RecordSet")
	set rcds2 = Application.CreateAppObject("RecordSet")
	sql = "[plotUid] = """ & plotUid & """ and [utype] < 3"
	cnt = 0
	rcds.Open gps, 1
	trcd = rcds.Find(sql)
	do while trcd>0
		xvalue = rcds.Fields("x").Value
		if xvalue <> 0 then
			cnt = cnt+1
		end if
		trcd = rcds.Find(sql,,trcd)
		if(cnt>5)then
			exit do
		end if
	loop
	rcds.Close
	if(cnt < 5)then
		Application.MessageBox "At least 5 GPS positions have not been collected! Setting visited to zero!", vbInformation
		call setVisitedZero
		exit sub
	end if
	cnt = 0
	redim slst(3)
	rcds.Open subplots, 1
	trcd = rcds.Find(sql)
	do while trcd>0
		suid = rcds.Fields("uid").Value
		sql2 = "[subplotUid] = """ & suid & """ and [utype] < 3"
		rcds2.Open trees, 1
		if rcds2.Find(sql2) = 0 then
			Application.MessageBox "Subplot = " & Cstr(rcds.Fields("subplot")) & " trees have not been collected! Setting visited to zero!", vbInformation
			rcds.Close
			rcds2.Close
			call setVisitedZero
			exit sub
		end if
		slst(cnt) = rcds.Fields("subplot").Value
		cnt = cnt+1
		trcd = rcds.Find(sql,,trcd)
		if(cnt>=4)then
			exit do
		end if
	loop
	rcds.Close
	if(cnt < 4)then
		Application.MessageBox "Subplot " & getSubPlotValue(slst) & " has not been collected! Setting visited to zero!", vbInformation
		call setVisitedZero
		exit sub
	end if
	path = replace(Layer.FilePath,Layer.Name&".shp","") & "PlotPics\" & plotUid & ".jpg"
	set fl = Application.CreateAppObject("file")
	if(not fl.Exists(path)) then
		Application.MessageBox "Picture has not been collected! Setting visited to zero!", vbinformation
		call setVisitedZero
		exit sub
	end if
	set rcds = nothing
	set rcds2 = nothing
end sub

function getSubPlotValue(mArr)
	dim outStr, i
	outStr = "1234"
	for each i in mArr
 		outStr = Replace(outStr, Cstr(i),"")
	Next
	outStr = left(outStr,1) 
	getSubPlotValue = outStr
end function
